POJ3126 Prime Path BFS搜索 TWT Tokyo Olympic 3combo-1

来源:互联网 发布:极乐净土的动作数据 编辑:程序博客网 时间:2024/05/29 16:55

Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 17744 Accepted: 9997

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006

虽然和图没有关系了,但是用搜索的想法去做还是没问题的。

用string来处理数字贡献了一发T

忘记打impossible的情况贡献了一发wa

改变数字的公式写错贡献两发wa

嗯。。。。感觉自己很傻逼

下面代码:

/* ━━━━━┒ ┓┏┓┏┓┃μ'sic foever!! ┛┗┛┗┛┃\○/ ┓┏┓┏┓┃ / ┛┗┛┗┛┃ノ) ┓┏┓┏┓┃ ┛┗┛┗┛┃ ┓┏┓┏┓┃ ┛┗┛┗┛┃ ┓┏┓┏┓┃ ┛┗┛┗┛┃ ┓┏┓┏┓┃ ┃┃┃┃┃┃ ┻┻┻┻┻┻ */#include <iostream>#include <cstdio>#include <cstdlib>#include <cmath>#include <cstring>#include <algorithm>#include <set>#include <map>#include <vector>#include <queue>#include <cmath>using namespace std;const int maxn=10010;const int INF=8000000;int start,endd;int vis[maxn];int digi[10]={0,1,2,3,4,5,6,7,8,9};int d[maxn];int result;bool flag;void init(){    long long i,j;    memset(vis, 0, sizeof(vis));    for(i=2;i<=maxn;i++){        if(!vis[i]){            for(j=i*i;j<=maxn;j+=i){                vis[j]=1;            }        }    }}/*int change(string a){int ans=0,p=0;int me=1000;while(p<a.length()){ ans+=(a[p]-'0')*me; me=me/10; p++;}return ans; }*/void bfs(){    queue<int> que;    int i,j;    for(i=1000;i<=9999;i++){        d[i]=INF;    }    d[0]=0;    que.push(start);    d[start]=0;    while(que.size()){        int q=que.front();        que.pop();        //cout<<q<<" "<<endd<<" "<<d[q]<<endl;        if(q==endd){            //cout<<"wht "<<q<<" "<<endd<<endl;            flag=true;            result=d[q];            break;        }        int np;        for(i=1;i<10;i++){            np=q+(i*pow(10,3)-q%(int)pow(10,4))+q%(int)pow(10,3);            if(!vis[np]&&d[np]==INF){                que.push(np);                d[np]=d[q]+1;            }        }        for(i=0;i<4;i++){            for(j=0;j<10;j++){                if(i>0){                    np=q+(j*pow(10,i)-q%(int)pow(10,i+1))+q%(int)pow(10,i);                }else{                    np=q+(j-q%10);                }                //cout<<np<<endl;                if(!vis[np]&&d[np]==INF){                    que.push(np);                    d[np]=d[q]+1;                }            }        }    }}int main(){    init();    int t;    scanf("%d",&t);    while(t--){        scanf("%d%d",&start,&endd);        result=0;        flag=false;        bfs();        if(flag){            printf("%d\n",result);        }else{            printf("Impossible\n");        }    }    return 0;}


0 0
原创粉丝点击